var MuteControl = 
    (function() {

         function MuteControl (options) {
             var thisp = this;
             Tools.optionHash(
                 options, 
                 {
                     element:$('#sound-control')
                 }
             );
             
             this.options = options;
             this.options.element.click(
                 function() {
                     thisp.toggle();
                 }
             );
             this.videos = [];
             this.videos$ = $();
             this.muted = false;
             this.muteUpdate();
             this.update = function () { thisp.muteUpdate(); };
         }
         
         MuteControl.prototype = {
             muted : function() {
                 return this.muted;
             },
             muteUpdate : function() {
                 if (this.muted) {
                     this.options.element.remove3Class('active');
                 } else {
                     this.options.element.add3Class('active');
                 }

                 this.videos$.prop('volume', this.muted ? 0 : 1);
             },
             
             toggle : function() {
                 this.muted = ! this.muted;
                 this.muteUpdate();
             },
             
             attach : function(video) {

                 this.videos.push(video);
                 this.videos$ = this.videos$.add(video);

                 video.bind('play.mutecontrol', this.update );
                 video.bind('pause.mutecontrol', this.update );
                 video.bind('ended.mutecontrol', this.update );                            
             },
             detach : function() {


                 if (this.videos.length > 0) {
                     this.videos$.unbind('.mutecontrol');
                     this.videos = [];
                     this.videos$ = $();
                 }
             }
             
         };
         return MuteControl;
     })();
